﻿/*
 * ----------------------------------------------------------------------------
 *
 *   Google Gadget Fastladder Notifier
 *
 *  Copyright (c) 2007, Tennetiss
 *  http://www.akaiho.com/
 *
 *
 *  CHANGELOG:
 *    2007-07-13  :  minor bug fixed.
 *    2007-07-08  :  when collapsed, shows the # of items on the caption
 *    2007-07-05  :  initially setup
 *
 * ----------------------------------------------------------------------------
 */

var kCurrentVersion = "1.02";
//var kLivedoorReaderURL = 'http://reader.livedoor.com/reader/';
//var kLivedoorAPIUrl = 'http://rpc.fastladder.com/notify?user=';
var kFastLadderURL = 'http://fastladder.com/reader/';
var kFastLadderAPIUrl = 'http://rpc.fastladder.com/notify?user=';

var kCheckIntervalMs; // refresh rate.

var timerId = null;   // time interval id
var http = null;      // http object
var fastladderUserId;   // userid
var lastCount = -1;   // unused
var postfixString;
var unreadtext;

var failStrings = new Array("failed");

function Main() {
  SetDefaultOptions();

  pluginHelper.onAddCustomMenuItems = AddCustomMenuItems;
  pluginHelper.onShowOptionsDlg = ShowOptionsDlg;
  fastladderUserId = options("Userid");
  postfixString = options("Postfix");

  ResetTimeInterval(options("Timeinterval"));
  unread.innerText = "lookup";
  RefreshDisplay();
}

function SetDefaultOptions() {
  options.defaultValue("Userid") = "";
  options.defaultValue("Timeinterval") = "10";
  options.defaultValue("Postfix") = " items";
}

function unread_over(){
  unread.bold = true;
}
function unread_out(){
  unread.bold = false;
}

// view_onminimize
function view_onminimize(){

  view.caption = unreadtext;
}

// view_onrestore
function view_onrestore(){
  view.caption = PLUGIN_TITLE;
}

//
// view_onopen
// 
function view_onopen()
{
  Main();
}


function ResetTimeInterval(newIntervalmin){
  kCheckIntervalMs = 1000 * 60 * newIntervalmin;
  if(timerId != null) { view.clearInterval(timerId); }
  timerId = view.setInterval("RefreshDisplay()", kCheckIntervalMs);
}


function OnOpenItem(item) { // open the fastladder as a web page with your default browser
  var wshShell = new ActiveXObject("WScript.Shell");
  wshShell.run(kFastLadderURL);
  wshShell = null;
}

function AddCustomMenuItems(menu) {
  menu.AddItem("Refresh", 0, RefreshDisplay);
}

function RefreshDisplay() {
//  var url = kFastLadderAPIUrl + fastladderUserId;

  if( fastladderUserId == "" ){ return; }
  var url = kFastLadderAPIUrl + fastladderUserId;
  http = new XMLHttpRequest();
  http.onreadystatechange = OnReceivedData;
  http.open("GET",  url, true);
  http.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT"); // do this, or it keeps reading cache
  try {
    http.send();
  }
  catch(e) {
  }
}

function OnReceivedData() {
  if (http && http.readyState == 4) { // completed OK?

    var count = http.responseText.split('|')[1];

//    gItem_unread.heading = count + postfixString;
    if((count == null) || (count == "undefined")){
      unread.innerText = failStrings[0];
      unreadtext = failStrings[0];
    }
    else {
      unread.innerText = count + "\n" + postfixString;
      unreadtext = count + " " + postfixString;
    }
    http = null;
  }
}


// ---- Options Dialog ----
function ShowOptionsDlg(wnd) {

//  wnd.AddControl(gddWndCtrlClassLabel, 0, "", ENTER,
//      30, 10, 200, 15);
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", ENTER_USERID,
      30, 10, 200, 15);
  wnd.AddControl(gddWndCtrlClassEdit, 0, "userid", options("Userid"),
      30, 25, 150, 22);

//  wnd.AddControl(gddWndCtrlClassLabel, 0, "", enterTimeInterval,
//                 30, 50, 200, 15);
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", ENTER_TIMEINTERVAL,
                 30, 50, 200, 15);
  wnd.AddControl(gddWndCtrlClassEdit, 0, "timeinterval", options("Timeinterval"),
                 30, 65, 150, 22);

  wnd.onClose = OptionsDlgClosed;
}


function OptionsDlgClosed(wnd, code) {
  if (code == gddIdOK) {
    var username = wnd.GetControl("userid");
    if(username.text == ""){
      alert("enter your ID");
    }
    else {
      options("Userid") = username.text;
      fastladderUserId = username.text;
    }

    var timeinterval = wnd.GetControl("timeinterval");
    if( isNaN(timeinterval.text) || (timeinterval.text <= 0) ){
      alert( inputTimeError );
    }
    else {
      options("Timeinterval") = timeinterval.text;
      ResetTimeInterval(timeinterval.text);
    }

    RefreshDisplay();
  }
}


